	.386
	.model flat, stdcall
	option casemap :none

	include externs.inc

SetCOMPort			PROTO :DWORD
P2K_Init			PROTO :DWORD
P2K3_Init			PROTO :DWORD
P2K_GetStatus		PROTO
P2K_GetInterface 	PROTO :DWORD, :DWORD
P2K_GetIFHandle		PROTO
P2K_PowerOff		PROTO
P2K_Restart			PROTO
P2K_Suspend			PROTO
P2K_SuspendEx		PROTO :DWORD
P2K_SendCMD			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
P2K_SwitchToFlash	PROTO

Mode_SwitchToP2K	PROTO :DWORD
Mode_SwitchToAT		PROTO
Mode_SwitchToTF		PROTO

Seem_Read			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
Seem_Write			PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD

File_Create			PROTO :DWORD, :DWORD
File_Read			PROTO :DWORD, :DWORD
File_Write			PROTO :DWORD, :DWORD
File_SetPointer		PROTO :DWORD, :BYTE
File_Close			PROTO

File_Delete			PROTO :DWORD
File_CreateDir		PROTO :DWORD, :DWORD
File_DeleteDir		PROTO :DWORD

File_Count			PROTO
File_CountEx		PROTO :DWORD
File_VolInfo		PROTO :DWORD
File_GetFreeSpace	PROTO :DWORD
File_List			PROTO :DWORD, :DWORD
File_ListEx			PROTO :DWORD, :DWORD, :DWORD

Flash_Addr			PROTO :DWORD
Flash_Jump			PROTO :DWORD
Flash_Bin			PROTO :DWORD, :DWORD
Flash_Dump			PROTO :DWORD, :DWORD

Flash_SendCmd		PROTO :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
Flash_ReadData		PROTO :DWORD, :DWORD, :DWORD
Flash_WriteData		PROTO :DWORD, :DWORD, :DWORD

		.code

File_DeleteDir  proc	near sDirName:DWORD
                push    esi
                push    edx
                push    ecx

                cmp     TCI_IF, -1
                jz      @@fail

                mov     Cmd_Recv_Size, 0
                mov     byte ptr Cmd_Recv_Buf, 0
                mov     dword ptr Cmd_Send_Buf, 0F000000h ; Cmd - del dir
                mov     dword ptr [Cmd_Send_Buf+4], 0
                mov     esi, sDirName
                push    esi
                call    lstrlenA
                xor     edx, edx
                cmp     eax, 0
                jz      @@fail

@@name_cpy_loop:
                mov     cl, [esi+edx]
                mov     byte ptr [Cmd_Send_Buf+8+edx], cl
                inc     edx
                cmp     edx, eax
                jl      short @@name_cpy_loop

                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                add     eax, 8
                push    eax
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD
                cmp     eax, 0
                jnz     @@fail
                cmp     Cmd_Recv_Size, 1
                jz      @@fail
                cmp     Cmd_Recv_Buf, 1
                jz      @@fail
                xor     eax, eax
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     ecx
                pop     edx
                pop     esi

                ret
File_DeleteDir  endp


File_CreateDir   proc	near sDirName:DWORD, dwAtrr:DWORD
                push    esi
                push    ebx
                push    ecx

                cmp     TCI_IF, -1
                jz      @@fail

                mov     edi, offset Cmd_Send_Buf
                mov     Cmd_Recv_Size, 0

                mov     eax, dwAtrr
                xchg    ah, al
                rol     eax, 10h
                xchg    ah, al
                mov     dword ptr [edi+04h], eax
                mov     dword ptr [edi+00h], 0E000000h ; Cmd 0E - Create Dir

                push    sDirName
                call    lstrlenA
                cmp     eax, 0
                jz      @@fail
                mov     ecx, 200h ; Maximum fname size
                cmp     eax, ecx
                ja      @@fail
                push    edi

                add     edi, 8
                mov     esi, sDirName ; fname
                xor     edx, edx
@@name_cpy_loop:
                mov     cl, [esi+edx]
                mov     [edi+edx], cl
                inc     edx
                cmp     edx, eax
                jl      short @@name_cpy_loop
                pop     edi

                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                add     eax, 8
                push    eax ; in data size - name len+8
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD
                
                xor     eax,eax  ; sorry for this. sometimes all ok, but function return error
                jmp     @@exit   ;

;                cmp     eax, 0
;                jnz     @@fail
;                cmp     word ptr Cmd_Recv_Size, 1
;                jz      @@fail
;                cmp     byte ptr Cmd_Recv_Buf, 1
;                jz      @@fail
                                    
;                xor     eax, eax
;                jmp     @@exit


@@fail:
                mov     eax, -1
@@exit:
                pop     ecx
                pop     ebx
                pop     esi

                ret
File_CreateDir  endp


File_Create     proc	near sFileName:DWORD, dwAtrr:DWORD
                push    esi
                push    ebx
                push    ecx

                cmp     TCI_IF, -1
                jz      @@fail

                cmp     File_opened, 0
                jnz     @@fail
                mov     edi, offset Cmd_Send_Buf
                mov     Cmd_Recv_Size, 0

                mov     eax, dwAtrr
                xchg    ah, al
                rol     eax, 10h
                xchg    ah, al
                mov     dword ptr [edi+04h], eax
                mov     dword ptr [edi+00h], 0 ; Cmd 0 - Open

                push    sFileName
                call    lstrlenA
                cmp     eax, 0
                jz      @@fail
                mov     ecx, 200h ; Maximum fname size
                cmp     eax, ecx
                ja      @@fail
                push    edi

                add     edi, 8
                mov     esi, sFileName ; fname
                xor     edx, edx
@@name_cpy_loop:
                mov     cl, [esi+edx]
                mov     [edi+edx], cl
                inc     edx
                cmp     edx, eax
                jl      short @@name_cpy_loop
                pop     edi

                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                add     eax, 8
                push    eax ; in data size - name len+8
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD
                cmp     eax, 0
                jnz     @@fail
                inc     File_opened
                cmp     Cmd_Recv_Size, 1
                jnz     short @@exit
                cmp     byte ptr Cmd_Recv_Buf, 0
                jnz     short @@exit
                xor     eax, eax
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     ecx
                pop     ebx
                pop     esi

                ret
File_Create     endp

File_Close      proc	near
                cmp     TCI_IF, -1
                jz      @@fail
                cmp     File_opened, 0
                jz      @@fail
                mov     Cmd_Recv_Size, 0
                mov     byte ptr Cmd_Recv_Buf, 0
                mov     dword ptr Cmd_Send_Buf, 04000000h ; Cmd
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    4
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 1
                jz      @@fail
                cmp     byte ptr Cmd_Recv_Buf, 1
                jz      @@fail
                dec     File_opened
                xor     eax, eax
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                ret
File_Close      endp

File_Read       proc 	near pBuffer:DWORD, dwSize:DWORD
                push    ecx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     edi, dwSize ; size
                cmp     edi, 0
                jz      @@fail

@@loop:
                cmp     edi, 400h
                jbe     @@b_400h
                mov     eax, 400h
                jmp     @@store_size
@@b_400h:
                mov     eax, edi
@@store_size:
                xchg    ah, al
                rol     eax, 10h
                xchg    ah,al

                mov     dword ptr Cmd_Send_Buf, 01000000h
                mov     dword ptr Cmd_Send_Buf+04h, eax

                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    8
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD

                cmp     eax, 0
                jnz     @@fail

                mov     ecx, Cmd_Recv_Size
                test    cx, cx
                jbe     short @@fail

                xor     esi, esi
                mov     eax, pBuffer
                add     eax, dwSize
                sub     eax, edi
@@buf_loop:
                mov     cl, byte ptr [Cmd_Recv_Buf+esi]
                mov     [esi+eax], cl

                mov     ecx, Cmd_Recv_Size
                inc     esi
                and     ecx, 0FFFFh
                cmp     esi, ecx
                jl      short @@buf_loop

                cmp     edi, 400h
                jbe     @@exit_ok
                sub     edi, 400h
                jmp     @@loop
@@exit_ok:
                mov     esi, 0
                jmp     @@exit
@@fail:
                mov     esi, -1
@@exit:
                mov     eax, esi
                pop     edi
                pop     esi
                pop     ebx
                pop     ecx

                ret
File_Read       endp

File_Write      proc	near pBuffer:DWORD, dwSize:DWORD
                push    edx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                xor     esi, esi
                mov     dword ptr Cmd_Send_Buf+0, 02000000h ; Cmd
                mov     Cmd_Recv_Size, 0
                mov     byte ptr Cmd_Recv_Buf, 0

                mov     ebx, dwSize ; Size

@@loop1:
                xor     eax, eax
                mov     edi, pBuffer

                cmp     ebx, 0
                jz      @@block_wr_ok
                cmp     ebx, 400h ; mstapi uses this buf size...
                jb      short @@last_block

                mov     edx, 400h
                jmp     @@loop_datacopy
@@last_block:
                mov     edx, ebx
@@loop_datacopy:
                push    edx
                xchg    dh, dl
                rol     edx, 10h
                xchg    dh, dl
                mov     dword ptr Cmd_Send_Buf+4, edx
                pop     edx

                mov     cl, [edi+esi]
                mov     byte ptr [Cmd_Send_Buf+8+eax], cl
                inc     eax
                inc     esi
                cmp     eax, edx
                jl      short @@loop_datacopy
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                add     edx, 8
                push    edx
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 1
                jnz     short @@block_wr_ok
                cmp     byte ptr Cmd_Recv_Buf, 6
                jnz     short @@fail
@@block_wr_ok:
                mov     eax, 0
                sub     edx, 8
                sub     ebx, edx
                jz      @@exit
                jmp     short @@loop1

@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
				
                ret
File_Write      endp

File_SetPointer proc	near dwOffset:DWORD, bMoveMethod:BYTE
                cmp     TCI_IF, -1
                jz      @@fail

                mov     dword ptr Cmd_Send_Buf, 03000000h ; Cmd

                mov     eax, dwOffset
                xchg    ah, al
                rol     eax, 10h
                xchg    ah, al
                mov     dword ptr Cmd_Send_Buf+4, eax
                mov     al, bMoveMethod
                mov     byte ptr Cmd_Send_Buf+8, al
                mov     Cmd_Recv_Size, 0
                mov     byte ptr Cmd_Recv_Buf, 0
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    9
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 1
                jz      @@fail
                cmp     byte ptr Cmd_Recv_Buf, 1
                jz      @@fail
                xor     eax, eax
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                ret
File_SetPointer endp

File_Delete     proc	near sFileName:DWORD
                push    esi
                push    edx
                push    ecx

                cmp     TCI_IF, -1
                jz      @@fail

                mov     Cmd_Recv_Size, 0
                mov     byte ptr Cmd_Recv_Buf, 0
                mov     dword ptr Cmd_Send_Buf, 05000000h ; Cmd
                mov     esi, sFileName
                push    esi
                call    lstrlenA
                xor     edx, edx
                cmp     eax, 0
                jz      @@fail

@@name_cpy_loop:
                mov     cl, [esi+edx]
                mov     byte ptr [Cmd_Send_Buf+4+edx], cl
                inc     edx
                cmp     edx, eax
                jl      short @@name_cpy_loop
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                add     eax, 4
                push    eax
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD
                cmp     eax, 0
                jnz     @@fail
                cmp     Cmd_Recv_Size, 1
                jz      @@fail
                cmp     Cmd_Recv_Buf, 1
                jz      @@fail
                xor     eax, eax
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     ecx
                pop     edx
                pop     esi

                ret
File_Delete     endp


File_GetFreeSpace proc	near sDiskName:DWORD
                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     byte ptr Cmd_Recv_Buf, 0
                mov     dword ptr Cmd_Send_Buf, 0B000000h ; Cmd
                mov     edi, offset Cmd_Send_Buf
                mov     esi, sDiskName
                mov     ecx, 4
                mov     word ptr [edi+ecx], 0700h
                add     ecx,2

                mov     byte ptr [edi+ecx], 0
                inc     ecx
                mov     al,[esi]
                mov     [edi+ecx],al
                inc     esi
                inc     ecx

                mov     byte ptr [edi+ecx], 0
                inc     ecx
                mov     al,[esi]
                mov     [edi+ecx],al
                inc     esi
                inc     ecx

                mov     byte ptr [edi+ecx], 0
                inc     ecx
                mov     al,[esi]
                mov     [edi+ecx],al
                inc     esi
                inc     ecx
                
                mov     word ptr [edi+ecx], 0
                add     ecx,2
                

                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    ecx
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 1
                jz      @@fail
                cmp     byte ptr [esi], 6
                jz      @@fail
              
                mov     edx, dword ptr Cmd_Recv_Buf
                xchg    dh, dl
                rol     edx, 10h
                xchg    dh, dl
                mov     eax,edx
                cmp     edx, 0                      ; in edx size of free space
              
                jnz     @@exit

@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx

                ret
File_GetFreeSpace endp


File_VolInfo    proc	near pBuffer:DWORD
                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     esi, pBuffer
                mov     ecx, 80h
                xor     eax, eax
                mov     edi, esi
                rep		stosd
                mov     word ptr Cmd_Recv_Buf, 0
                mov     dword ptr Cmd_Send_Buf, 0A000000h ; Cmd

                push    offset Cmd_Recv_Size
                push    esi
                push    4
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 1
                jz      @@fail
                cmp     byte ptr [esi], 6
                jz      @@fail

                mov     edi, offset Cmd_Send_Buf
                mov     ecx, 80h
                xor     eax, eax
                rep stosd

                mov     byte ptr Cmd_Recv_Buf, 0
                mov     dword ptr Cmd_Send_Buf, 0B000000h ; Cmd
                mov     edi, offset Cmd_Send_Buf
                add     edi, 4
                mov     ax, 0
                stosw
                mov     esi, pBuffer
@@loop:
                lodsw
                cmp     ax, 0
                jz      @@go_fsac
                stosw
                inc     ecx
                cmp     ecx, 80h
                jl      short @@loop

@@go_fsac:
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    200h
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 1
                jz      @@fail
                cmp     byte ptr [esi], 6
                jz      @@fail
              
                mov     edx, dword ptr Cmd_Recv_Buf
                xchg    dh, dl
                rol     edx, 10h
                xchg    dh, dl
                cmp     edx, 0 
              
                jnz     @@ok
                jmp     @@fail
@@ok:
                mov     esi, pBuffer
                mov     edi, pBuffer
@@cvt_loop:
                lodsw
                xchg    ah, al
                stosb
                cmp     al, 0
                jnz     @@cvt_loop

                mov     eax, edx
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx

                ret
File_VolInfo    endp

File_Count      proc	near
                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi
; Request files count
                cmp     TCI_IF, -1
                jz      @@fail

                mov     word ptr Cmd_Recv_Buf, -1
                mov     dword ptr Cmd_Send_Buf, 07000000h ; Cmd
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    4
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 2
                jb      @@fail
                cmp     word ptr Cmd_Recv_Buf, 0
                jbe     @@fail                           ; nothing to search
                cmp     word ptr Cmd_Recv_Buf, -1
                jz      @@fail

                xor     eax, eax
                mov     ax, word ptr Cmd_Recv_Buf
                xchg    ah, al
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx

                ret
File_Count      endp


File_CountEx    proc	near sDiskNameAndMask:DWORD
                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi
                
                mov     edi, sDiskNameAndMask          ; edi - search mask:  /b/*.*
                mov     esi, offset Cmd_Send_Buf
                mov     ecx, 4                    ; ecx - offset in Cmd_Send_Buf
                xor     eax, eax                  ; eax - offset in mask


@@again1:       cmp byte ptr [edi+eax], '*'
                jz      @@end_of_path
                mov     byte ptr [esi+ecx], 0
                inc     ecx
                mov     bl, [edi+eax]
                mov     [esi+ecx], bl
                inc     eax
                inc     ecx
                jmp     @@again1

@@end_of_path:                
               
                mov     word ptr [esi+ecx], 0FEFFh
                add     ecx,2

@@again:        cmp     byte ptr [edi+eax], 0
                jz      @@end_of_mask
                mov     byte ptr [esi+ecx], 0
                inc     ecx
                mov     bl, [edi+eax]
                mov     [esi+ecx], bl
                inc     eax
                inc     ecx
                jmp     @@again
@@end_of_mask:
                mov     word ptr [esi+ecx], 0
                add     ecx,2
                
                
; Request files count
                cmp     TCI_IF, -1
                jz      @@fail

                mov     word ptr Cmd_Recv_Buf, -1
                mov     dword ptr Cmd_Send_Buf, 07000000h ; Cmd
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    ecx
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 2
                jb      @@fail
                cmp     word ptr Cmd_Recv_Buf, 0
                jbe     @@fail                           ; nothing to search
                cmp     word ptr Cmd_Recv_Buf, -1
                jz      @@fail

                xor     eax, eax
                mov     ax, word ptr Cmd_Recv_Buf
                xchg    ah, al
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx

				ret
File_CountEx    endp

File_List       proc	near pBuffer:DWORD, dwCount:DWORD
                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     esi, dwCount
                mov     edi, pBuffer

@@loop:
; request block of records
                mov     word ptr Cmd_Recv_Buf, -1
                mov     dword ptr Cmd_Send_Buf, 08000000h ; Cmd
                mov     byte ptr Cmd_Send_Buf+4, 03h
                push    offset Cmd_Recv_Size
                push    offset Search_Buf
                push    5
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD

                cmp     eax, 0
                jnz     @@fail

                mov     eax, Cmd_Recv_Size
                sub     eax, 4
                cdq
                mov     ecx, 2Ch
                mov     FileList_RecSize, ecx
                idiv    ecx
                cmp     edx, 0
                jz      @@rec_ok

                mov     eax, Cmd_Recv_Size
                sub     eax, 4
                cdq
                mov     ecx, 10Ch
                mov     FileList_RecSize, ecx
                idiv    ecx
                cmp     edx, 0
                jz      @@rec_ok
                mov     edx, 0
                mov     FileList_RecSize, edx
                jmp     @@fail

@@rec_ok:
                movzx   eax, word ptr [Search_Buf] ; records readed
                xchg    ah, al
                sub     esi, eax

                push    esi
                mov     ecx, eax
                mov     esi, offset Search_Buf
                add     esi, 4

@@copy_loop:
                mov     ebx, FileList_RecSize
                mov     eax, [esi+ebx-4]
                xchg    ah, al
                rol     eax,10h
                xchg    ah,al
                stosd
                mov     ax, [esi+ebx-6h]
                xchg    ah, al
                stosw
                mov     ax, [esi+ebx-8]
                xchg    ah, al
                stosw

                push    esi
                push    edi
                push    ecx
                mov     ecx, FileList_RecSize
                sub     ecx, 8
                rep     movsb
                mov     al, 0
                stosb
                pop     ecx
                pop     edi
                pop     esi
                add     esi, FileList_RecSize
                add     edi, 1F8h
                loop    @@copy_loop

                pop     esi

                cmp     esi, 0
                ja      @@loop

                mov     eax, FileList_RecSize
                sub     eax, 8
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx

                ret
File_List       endp


File_ListEx     proc	near pBuffer:DWORD, dwCount:DWORD, pProgressCallBack:DWORD
                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     FileRecCount,0
                mov     esi, dwCount
                mov     edi, pBuffer

@@loop:
; request block of records
                mov     word ptr Cmd_Recv_Buf, -1
                mov     dword ptr Cmd_Send_Buf, 08000000h ; Cmd
                mov     byte ptr Cmd_Send_Buf+4, 03h
                push    offset Cmd_Recv_Size
                push    offset Search_Buf
                push    5
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
;                push    TCI_IF
                call    P2K_SendCMD

                cmp     eax, 0
                jnz     @@fail

                mov     eax, Cmd_Recv_Size
                sub     eax, 4
                cdq
                mov     ecx, 2Ch
                mov     FileList_RecSize, ecx
                idiv    ecx
                cmp     edx, 0
                jz      @@rec_ok

                mov     eax, Cmd_Recv_Size
                sub     eax, 4
                cdq
                mov     ecx, 10Ch
                mov     FileList_RecSize, ecx
                idiv    ecx
                cmp     edx, 0
                jz      @@rec_ok
                mov     edx, 0
                mov     FileList_RecSize, edx
                jmp     @@fail

@@rec_ok:
                movzx   eax, word ptr [Search_Buf] ; records readed
                xchg    ah, al
                sub     esi, eax

                push    esi
                mov     ecx, eax
                mov     esi, offset Search_Buf
                add     esi, 4

@@copy_loop:
                mov     ebx, FileList_RecSize
                mov     eax, [esi+ebx-4]
                xchg    ah, al
                rol     eax,10h
                xchg    ah,al
                stosd
                mov     ax, [esi+ebx-6h]
                xchg    ah, al
                stosw
                mov     ax, [esi+ebx-8]
                xchg    ah, al
                stosw

                push    esi
                push    edi
                push    ecx
                mov     ecx, FileList_RecSize
                sub     ecx, 8
                rep     movsb
                mov     al, 0
                stosb
              
                pushad
                push    dwCount
                push    FileRecCount
                push    pBuffer
                mov     esi, pProgressCallBack
                call    esi
                popad
                inc     FileRecCount
              
                pop     ecx
                pop     edi
                pop     esi
                add     esi, FileList_RecSize
                add     edi, 1F8h
                loop    @@copy_loop

                pop     esi

                cmp     esi, 0
                ja      @@loop

                mov     eax, FileList_RecSize
                sub     eax, 8
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx

                ret
File_ListEx       endp


Seem_Read       proc	near dwSeemNo:DWORD, dwRecordNo:DWORD, dwStartOffset:DWORD, dwBytes:DWORD, pBuffer:DWORD
                push    ecx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     eax, dwSeemNo ; seem
                xchg    al, ah
                mov     seem_num, ax

                mov     eax, dwRecordNo ; record
                xchg    al, ah
                mov     seem_rec, ax

                mov     eax, dwStartOffset ; ofs
                xchg    al, ah
                mov     seem_ofs, ax

                mov     eax, dwBytes ; bytes
                xchg    al, ah
                mov     seem_bytes, ax


                mov     seem_read_bytes, 0

                push    offset seem_read_bytes
                push    offset seem_buf
                push    8                     ; DataBuf size
                push    offset seem_num
                push    020h           ; COMMAND - RDELEM
;                push    TCI_IF
                call    P2K_SendCMD
                test    eax, eax
                jnz     @@fail
                mov     eax, 0
                mov     ecx, seem_read_bytes
                cmp     seem_read_bytes, 0
                jbe     short @@ok
                mov     edi, pBuffer
                mov     bl, seem_buf
                test    bl, bl
                jnz     @@fail
@@ok:
                mov     edi, pBuffer
                mov     esi, offset seem_buf+1
                mov     ecx, seem_read_bytes
                dec     ecx
                rep     movsb
                mov     eax, seem_read_bytes
                dec     eax
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     ecx
                
				ret
Seem_Read       endp

Seem_Write      proc	near dwSeemNo:DWORD, dwRecordNo:DWORD, dwStartOffset:DWORD, dwBytes:DWORD, pBuffer:DWORD
                push    ecx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     eax, dwSeemNo ; seem
                xchg    al, ah
                mov     seem_num, ax

                mov     eax, dwRecordNo ; record
                xchg    al, ah
                mov     seem_rec, ax

                mov     eax, dwStartOffset ; ofs
                xchg    al, ah
                mov     seem_ofs, ax

                mov     eax, dwBytes ; bytes
                cmp     eax,0
                jbe     @@fail
                cmp     eax, 2710h
                jna     @@zize_ok
                mov     eax, 2710h
@@zize_ok:
                mov     dwBytes, eax
                xchg    al, ah
                mov     seem_bytes, ax

                mov     esi, pBuffer
                mov     edi, offset seem_data
                mov     ecx, dwBytes
                rep     movsb

                mov     seem_read_bytes, 0

                push    offset seem_read_bytes
                push    offset stelem_result

                mov     eax, dwBytes ; bytes
                add     eax, 8
                push    eax                   ; DataBuf size
                push    offset seem_num

                push    02Fh        ; COMMAND STELEM
;                push    TCI_IF
                call    P2K_SendCMD
                test    eax, eax
                jnz     @@fail
                mov     eax, 0
                mov     bl, byte ptr stelem_result
                test    bl, bl
                jz      short @@ok
@@fail:
                mov     eax, -1
@@ok:
                pop     edi
                pop     esi
                pop     ebx
                pop     ecx

                ret
Seem_Write      endp

P2K_SuspendEx   proc    near dwSuspType:DWORD
                cmp     TCI_IF, -1
                jz      @@fail
                mov     eax,[ebp+arg_0]
                mov     byte ptr Cmd_Send_Buf, al
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    1
                push    offset Cmd_Send_Buf
                push    0036h                   ; SUSPEND
;                push    TCI_IF
                call    P2K_SendCMD
                movzx   eax,byte ptr Cmd_Recv_Buf
@@fail:
                ret
P2K_SuspendEx   endp

P2K_PowerOff    proc	near
                cmp     TCI_IF, -1
                jz      @@fail
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    0
                push    offset Cmd_Send_Buf
                push    001Eh                   ; PWROFF
;                push    TCI_IF
                call    P2K_SendCMD
@@fail:
                ret
P2K_PowerOff    endp

P2K_Suspend     proc	near
                cmp     TCI_IF, -1
                jz      @@fail
                mov     byte ptr Cmd_Send_Buf, 0
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    1
                push    offset Cmd_Send_Buf
                push    0036h                   ; SUSPEND
;                push    TCI_IF
                call    P2K_SendCMD
@@fail:
                ret
P2K_Suspend     endp

P2K_Restart     proc    near
                cmp     TCI_IF, -1
                jz      @@fail
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    0
                push    offset Cmd_Send_Buf
                push    0022h                  ; RESTART
;                push    TCI_IF
                call    P2K_SendCMD
@@fail:
                ret
P2K_Restart     endp

SetCOMPort      proc	near sPort:DWORD
                push    esi
                push    edi
                push    ecx
                push    eax
                
                mov     esi, [ebp+arg_0]

                cmp     esi,0
                jnz     @@manual
                mov     ManualCOM, 00h
                jmp     @@exit

@@manual:
                mov     ManualCOM, 01h
                mov     edi, offset keyval_buf
                xor     ecx, ecx
@@cpy:                
                mov     al, [esi+ecx]
                mov     [edi+ecx],al
                inc     ecx
                cmp     al,0                
                jnz     @@cpy


@@exit:
                pop     eax
                pop     ecx
                pop     edi
                pop     esi

                ret
SetCOMPort      endp


Mode_SwitchToP2K proc	near pCallBack:DWORD
                cmp     Thread_Handle, 00h
                jnz     @@inited
				
                push    pCallBack
                call    P2K_Init
				jmp     @@done
@@inited:
                cmp     Thread_Suspended, 00h
                jz      @@done
                
                
                push    Thread_Handle
                call    ResumeThread
                mov     Thread_Suspended, 1h
@@done:
                ret
Mode_SwitchToP2K endp


Mode_SwitchToTF proc	near
                call    Mode_SwitchToAT
                mov     HackModeTF, 1
                push    0
                call    Mode_SwitchToP2K
@@done:                
                ret
Mode_SwitchToTF endp


Mode_SwitchToAT proc	near
                 push    ecx
                 push    ebx
                 push    esi
                 push    edi
 
                 cmp     TCI_IF, -1
                 jz      @@done

                 cmp     Thread_Suspended,00h
                 jnz     @@done
                 cmp     Thread_Handle,00h
                 jz      @@done
                 push    Thread_Handle
                 call    SuspendThread
                 mov     Thread_Suspended,1h
         
                 mov     packet_size,9
                 push    offset packet_size
                 push    offset SwitchToAT_Buff
                 call    USB_WriteData
@@done:                
                 mov     DevFound,0
                 cmp     Mon_CB, 0
                 jz      @@skip_mon_cb
                 push    0
                 call    Mon_CB
@@skip_mon_cb:
                 pop     edi
                 pop     esi
                 pop     ebx
                 pop     ecx

                 ret    
Mode_SwitchToAT  endp

P2K_SwitchToFlash proc	near
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    0 ; in data size - name len+8
                push    offset Cmd_Send_Buf
                push    00Dh                   ; FLASH
                call    P2K_SendCMD
                ret
P2K_SwitchToFlash endp

P2K_IntInit     proc	near
arg_0           = dword ptr  8

                push    ebp
                mov     ebp, esp
                mov     eax, [ebp+arg_0]
                mov     Mon_CB, eax
                
                cmp     Thread_Handle,0FFFFFFFFh
                jz      @@already_inited
                
         ;       mov     ManualCOM, 01h
         ;       mov     esi, offset str_usb_modem
         ;       mov     edi, offset keyval_buf
         ;       xor     ecx, ecx
;@@cpy:                
         ;       mov     al, [esi+ecx]
         ;       mov     [edi+ecx],al
         ;       inc     ecx
         ;       cmp     al,0                
         ;       jnz     @@cpy
                
                push    offset Thread_Id
                push    0
                push    0
                push    offset DevMonitor_Proc
                push    0
                push    0
                call    CreateThread
                mov     Thread_Handle, eax
                jmp     @@done

@@already_inited:
                cmp     Thread_Suspended, 00h
                jz      @@done
                push    Thread_Handle
                call    ResumeThread
                
@@done:                
                mov  eax,0
                leave
                ret 4
P2K_IntInit     endp

P2K_Init        proc    near pCallBack:DWORD

                mov     IsExInited, 0
                push    pCallBack
                call    P2K_IntInit

                ret
P2K_Init        endp

P2K3_Init       proc    near pCallBack:DWORD

                mov     IsExInited,1
                push    [ebp+arg_0]
                call    P2K_IntInit

                ret
P2K3_Init       endp

P2K_GetStatus   proc	near
                mov  eax, DevFound
                ret
P2K_GetStatus   endp

P2K_GetInterface proc   near sInterface:DWORD, dwSize:DWORD
                push    lpIFName
                call    lstrlenA
                inc     eax
                cmp     eax, dwSize
                ja      NoWrite
                push    eax
                push    lpIFName
                push    sInterface
                call    lstrcpyA
                pop     eax
NoWrite:
                ret
P2K_GetInterface endp

DevMonitor_Proc proc	near
@@init_fail:
                mov     FI_IF,-1
                mov     TCI_IF, -1
                ;push    3E8h
                push    100h
                call    Sleep
                call    SwitchFromDataCard
;                push    3E8h
;                call    Sleep
                cmp     ManualCOM,1
                jz      @@man_com
                call    COM_Find
                cmp     eax, 0
                jnz     @@no_comm
                jmp     @@auto_com
@@man_com:               
                ;in keyval_buf must be our com port 
                call    Switch_mode
                test    eax,eax
                jnz     @@no_comm
                
@@auto_com:
                ;push    1388h
                push    300h
                call    Sleep
                cmp     HackModeTF,1
                jnz     @@skip_hack
                mov     DevFound,0
                push    Thread_Handle
                call    SuspendThread
                mov     Thread_Suspended,1h
                
                jmp     @@hack
@@no_comm:

@@skip_hack:
                call    FindUSBClass
@@hack:                
                mov     HackModeTF,0
                cmp     DevFound, 1
                jnz     @@init_fail



                mov     eax, Dev_Name_Ptr
                add     eax, 4
                push    eax
                push    offset str_devclass_key
                push    offset str_buf
                call    wsprintfA
                add     esp, 0Ch
                mov     byte ptr [str_buf+56h], '#'
                mov     byte ptr [str_buf+57h], '#'
                mov     byte ptr [str_buf+59h], '#'

                ; str_buf
;                push    offset MI
;                push    offset str_buf
;                call    StrStrIA
;                cmp     eax,0
;                jz      @@not_found_mi
;                add     eax,4
;                mov     bl,[eax]
;                sub     bl,48
;                shl     bl,4
;                inc     eax
;                mov     bh,[eax]
;                sub     bh,48
;                or      bl,bh
;                xor     bh,bh
;                mov     IFindex,bx
;                jmp     @@found_mi
;@@not_found_mi:
;                mov     IFindex, 0FFFFh
;@@found_mi:                

                call    Test_P2K_ver

                cmp     Mon_CB, 0
                jz      @@skip_cb_on
                push    0
                push    0
                call    P2K_GetInterface
                push    eax
                push    0
                call    GlobalAlloc
                mov     ebx,eax
                push    lpIFName
                push    ebx
                call    lstrcpyA
                cmp     IsExInited,1
                jnz     @@on_skip_arg1
                push    ebx
@@on_skip_arg1:
                movzx   eax,DevType
                push    eax
                call    Mon_CB
                push    ebx
                call    GlobalFree
@@skip_cb_on:
                
                
                push    offset Key_Class_handle  ; handle
                push    20019h         ; access mask
                push    0              ; res
                push    offset str_buf ; subkey
                push    80000002h      ; key
                call    RegOpenKeyExA

                push    0 ; async flag
                push    0; Key_Event
                push    5 ;notify filter - name+last_set
                push    1 ; flag subkey notify
                push    Key_Class_handle
                call    RegNotifyChangeKeyValue

                push    Key_Class_handle
                call    RegCloseKey
                cmp     Mon_CB, 0
                jz      @@skip_cb_off
                cmp     IsExInited,1
                jnz     @@off_skip_arg1
                push    0
@@off_skip_arg1:
                push    0
                call    Mon_CB
@@skip_cb_off:
                push    Dev_Name_Ptr
                call    GlobalFree
                mov     DevFound, 0
                mov     lpIFName,0
                push    1388h
                call    Sleep
                jmp     @@init_fail
DevMonitor_Proc endp

P2K_SendCMD proc	near dwCommand:DWORD, pSendBuff:DWORD, dwSendSize:DWORD, pRecvBuff:DWORD, pdwRecvSize:DWORD
                push    pdwRecvSize
                push    pRecvBuff
                push    dwSendSize
                push    pSendBuff
                push    dwCommand
                cmp     P2K05,1
                je      @@p05
                call    P2K00_SendCMD
                jmp     @@done
@@p05:
                call    P2K05_SendCMD
@@done:                
                ret
P2K_SendCMD endp


P2K00_SendCMD proc	near

arg_4           = dword ptr  8
arg_8           = dword ptr  0Ch
arg_C           = dword ptr  10h
arg_10          = dword ptr  14h
arg_14          = dword ptr  18h


                push    ebp
                mov     ebp, esp

                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi
                inc     Packet_ID
                cmp     Packet_ID, 1000h
                jb      @@skip_id_fix
                mov     Packet_ID, 0
@@skip_id_fix:

                mov     edi, offset packet_buf
                mov     ecx, 400h
                xor     eax, eax
                rep     stosd

                mov     ax, IFindex
                mov     edi, offset packet_buf
                mov     byte ptr [edi+00h], 41h
                mov     byte ptr [edi+01h], 02h
                mov     word ptr [edi+02h], 0000h
                mov     word ptr [edi+04h], ax ; Interface
                mov     eax, [ebp+arg_C]
                add     eax, 8
                mov     word ptr [edi+06h], ax    ; size ws command & size
                mov     dx, Packet_ID
                and     dx, 0FFFh
                xchg    dh, dl
                mov     word ptr [edi+08h], dx ; random - Packet ID
                mov     edx, [ebp+arg_4]
                and     dx,0FFFh
                xchg    dh,dl
                mov     word ptr [edi+0Ah], dx ; command
                mov     eax, [ebp+arg_C]
                xchg    ah, al
                mov     word ptr [edi+0Ch], ax    ; size
                mov     word ptr [edi+0Eh], 0000h
                mov     eax, [ebp+arg_C]
                add     eax, 12h
                mov     packet_size, eax
                mov     esi, [ebp+arg_8]
                add     edi, 10h
                mov     ecx, [ebp+arg_C]
                rep     movsb

                push    offset packet_size
                push    offset packet_buf
;                push    TCI_IF
                call    USB_WriteData
                cmp     eax, 0
                jz      @@Write_ok

;                push    offset msg_cmd_write_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit

@@Write_ok:
                call    GetTickCount
                mov     ReadStatus_Ticks, eax
@@status_loop:
                mov     edi, offset status_read_buf
                mov     ecx, 3
                xor     eax, eax
                rep     stosd

                mov     ax, IFindex
                mov     edi, offset status_read_buf
                mov     byte ptr [edi+00h], 0C1h
                mov     byte ptr [edi+01h], 0
                mov     word ptr [edi+02h], 0
                mov     word ptr [edi+04h], ax
                mov     word ptr [edi+06h], 8

                mov     status_read_size, 0Ch

                push    offset status_read_size
                push    offset status_read_buf
;                push    TCI_IF
                call    USB_ReadData

                cmp     eax, 0
                jnz     @@next_try
                mov     al, status_read_buf+1
                cmp     al, 3
                jae     @@next_try
                cmp     al, 0
                jnz     @@done
@@next_try:
                push    1
                call    Sleep

                call    GetTickCount
                sub     eax, ReadStatus_Ticks
                cmp     eax, 9C40h ; timeout
                jb      @@status_loop

;                push    offset msg_cmd_timeout
;                call    logstat
                mov     eax,-1
                jmp     @@exit

@@done:
                push    1
                call    Sleep

                mov     edi, offset data_read_buf
                mov     ecx, 400h
                xor     eax, eax
                rep     stosd

                mov     cx, IFindex
                mov     edi, offset data_read_buf
                mov     byte ptr [edi+00h], 0C1h
                mov     byte ptr [edi+01h], 1
                movzx   ax, byte ptr status_read_buf+1
                mov     word ptr [edi+02h], ax ; packets #
                mov     word ptr [edi+04h], cx ; IF

                shl     ax, 1
                mov     cx, word ptr status_read_buf+2
                xchg    ch, cl
                add     ax, cx
;                add     ax, word ptr status_read_buf+4
;                add     ax, word ptr status_read_buf+6
                add     ax, 4
                mov     word ptr [edi+06h], ax ; Size

                mov     data_read_size, 0FA4h
                push    offset data_read_size
                push    offset data_read_buf
;                push    TCI_IF
                call    USB_ReadData
                cmp     eax, 0
                jz      @@Read_ok

;                push    offset msg_cmd_read_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@Read_ok:
                mov     esi, offset data_read_buf
                cmp     byte ptr [esi+00h], 1
                jnz     @@fail
                mov     cx, [esi+04h]
                xchg    ch,cl
                mov     dl, [esi+06h]
                and     dl, 80h
                cmp     dl, 80h
                jnz     @@fail
                mov     dx, [esi+06h]
                xchg    dh, dl
                and     dx, 0FFFh ; Packet ID
                cmp     Packet_ID, dx
                jnz     @@fail
                mov     dl, [esi+08h]
                shr     dl, 4

                cmp     dl, 6        ; Answ 6 - result ok, no data returned
                mov     eax, 0
                jz      @@exit

                cmp     dl, 8        ; Answ 8 - result ok
                jz      @@op_ok
                and     edx, 0Fh
;                mov     eax, [IO_Err+edx*4]
;                push    eax
;                call    logstat
                mov     USB_Last_Err, eax
                mov     eax, -1
                jmp     @@exit
@@op_ok:
                mov     dx, [esi+0Ah]
                xchg    dh, dl
                sub     cx, 8
                cmp     cx, dx
                jnz     @@fail ; bad packet - size mismatch
                jmp     @@ok

@@fail:
;                push    offset msg_cmd_answer_fail
;                call    logstat
                mov     eax, 1
                jmp     @@exit

@@ok:
                add     esi, 0Eh
                mov     edi, [ebp+arg_10]
                mov     eax, [ebp+arg_14]
                and     ecx, 0FFFFh
                mov     [eax], ecx
                rep     movsb
                mov     eax, 0
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                ret    14h

P2K00_SendCMD endp



P2K05_SendCMD proc	near

arg_4           = dword ptr  8
arg_8           = dword ptr  0Ch
arg_C           = dword ptr  10h
arg_10          = dword ptr  14h
arg_14          = dword ptr  18h


                push    ebp
                mov     ebp, esp

                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi
                
                inc     Packet_ID
                cmp     Packet_ID, 1000h
                jb      @@skip_id_fix
                mov     Packet_ID, 0
@@skip_id_fix:

                mov     edi, offset packet_buf2
                mov     ecx, 400h
                xor     eax, eax
                rep     stosd

                mov     edi, offset packet_buf2
                
                mov     dx, Packet_ID
                and     dx, 0FFFh
                xchg    dh, dl
                mov     word ptr [edi], dx ; random - Packet ID
                mov     edx, [ebp+arg_4]
                and     dx,0FFFh
                xchg    dh,dl
                mov     word ptr [edi+02h], dx ; command
                
                mov     word ptr  [edi+04h], 0000h
                mov     dword ptr [edi+06h], 00000000h
                
                mov     eax, [ebp+arg_C]
                xchg    ah, al
                mov     word ptr [edi+0Ah], ax    ; size
                
                
                mov     eax, [ebp+arg_C]
                add     eax, 0ch
                mov     packet_size2, eax
                mov     esi, [ebp+arg_8]
                add     edi, 0ch
                mov     ecx, [ebp+arg_C]
                rep     movsb

                mov     eax, offset packet_buf2
                push    P2KTimeOut
                ;push    dword 2710h
                push    2
                push    offset packet_size2
                push    eax
                call    USB_WriteDataEx

                cmp     eax, 0
                jz      @@Write_ok

                mov     eax, -1
                jmp     @@exit

@@Write_ok:

                mov     esi, offset status_read_buf
                mov     ecx, 250h
                xor     eax, eax
                mov     edi, esi
                rep		stosd


                mov     status_read_size, 1000h

                push    P2KTimeOut
                ;push    dword 2710h
                push    2
                push    offset status_read_size
                push    offset status_read_buf
                call    USB_ReadDataEx
                jmp     @@ok

@@fail:
                mov     eax, 1
                jmp     @@exit

@@ok:
                mov     edi, [ebp+arg_10]
                mov     ecx, status_read_size
                sub     ecx, 0ch
                mov     esi, offset status_read_buf
                add     esi, 0ch
                mov     eax, [ebp+arg_14]
                mov     [eax],ecx
                rep     movsb
                mov     eax, 0
@@exit:

                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                ret    14h

P2K05_SendCMD endp

P2K_GetIFHandle proc    near
                mov     eax, Def_IF
                ret
P2K_GetIFHandle endp

Flash_WriteData proc    near pSendBuff:DWORD, pdwSendSize:DWORD, dwTimeout:DWORD
                mov     eax,FI_IF
                cmp     eax,-1
                je      @@no_if
                push    dwTimeout
                push    2
                push    pdwSendSize
                push    pSendBuff
                call    USB_WriteDataEx
@@no_if:
                ret
Flash_WriteData endp

Flash_ReadData  proc    near pSendBuff:DWORD, pdwSendSize:DWORD, dwTimeout:DWORD
                mov     eax,FI_IF
                cmp     eax,-1
                je      @@no_if
                push    dwTimeout
                push    2
                push    pdwSendSize
                push    pSendBuff
                call    USB_ReadDataEx
@@no_if:
                ret
Flash_ReadData  endp

Flash_SendCmd   proc    near arg04:DWORD, arg08:DWORD, arg0C:DWORD, arg10:DWORD, arg14:DWORD, arg18:DWORD
                push    esi
                push    edi
                mov     eax, arg0C
                cmp     eax, 0f00h
                ja      @@err
                lea     edi, Cmd_Send_Buf
                mov     byte ptr [edi], 2
                inc     edi
                mov     esi, arg04
                push    esi
                call    lstrlenA
                mov     ecx, eax
                rep     movsb
                cmp     arg08, 0
                je      @@no_data
                cmp     arg0C, 0
                je      @@no_data
                mov     byte ptr [edi], 1eh
                inc     edi
                mov     esi, arg08
                mov     ecx, arg0C
                rep     movsb
@@no_data:
                mov     byte ptr [edi], 3
                lea     eax, [edi+1]
                sub     eax, offset Cmd_Send_Buf
                mov     Cmd_Send_Size, eax
                push    arg18
                push    offset Cmd_Send_Size
                push    offset Cmd_Send_Buf
                call    Flash_WriteData
                cmp     eax, -1
                je      @@err
                push    arg18
                push    arg14
                push    arg10
                call    Flash_ReadData
                cmp     eax, -1
                je      @@err
                xor     eax, eax
                jmp     @@exit
@@err:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi

                ret
Flash_SendCmd   endp
                
PutAddr         proc
arg_4           = dword ptr 8
arg_8           = dword ptr 0ch
                push    ebp
                mov     ebp,esp
                push    esi
                push    [ebp+arg_4]
                push    offset Fmt_8Hex
                push    [ebp+arg_8]
                call    wsprintfA
                add     esp,12
                mov     esi,[ebp+arg_8]
                mov     ecx,8
                xor     eax,eax
                mov     edx,eax
@@next_char:
                mov     al,byte ptr [esi]
                add     edx,eax
                inc     esi
                loop    @@next_char
                movzx   edx,dl
                push    edx
                push    offset Fmt_2Hex
                push    esi
                call    wsprintfA
                add     esp,12
                pop     esi
                leave
                ret    8
PutAddr         endp

CheckAck        proc
arg_4           = dword ptr 8
                push    ebp
                mov     ebp,esp
                mov     eax,[ebp+arg_4]
                mov     eax,dword ptr [eax]
                mov     edx,dword ptr RespAck
                cmp     eax,edx
                je      @@equal
                mov     eax,-1
                jmp     @@exit
@@equal:
                xor     eax,eax
@@exit:
                leave
                ret    4
CheckAck        endp

Flash_AddrCmd   proc
arg_4           = dword ptr 8
arg_8           = dword ptr 0ch
                push    ebp
                mov     ebp,esp
                push    offset packet_buf
                push    [ebp+arg_4]
                call    PutAddr
                push    1000
                mov     Cmd_Recv_Size,1000h
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    10
                push    offset packet_buf
                push    [ebp+arg_8]
                call    Flash_SendCmd
                cmp     eax,-1
                je      @@exit
                push    offset Cmd_Recv_Buf
                call    CheckAck     
@@exit:         
                leave
                ret    4
Flash_AddrCmd   endp

Flash_Addr      proc	near dwAddress:DWORD
                push    ebp
                mov     ebp,esp
                push    offset CmdAddr
                push    dwAddress
                call    Flash_AddrCmd

                ret
Flash_Addr      endp

Flash_Jump      proc	near dwAddress:DWORD
                push    offset CmdJump
                push    dwAddress
                call    Flash_AddrCmd

                ret
Flash_Jump      endp

Flash_Bin       proc	near pSendBuff:DWORD, dwSendSize:DWORD
                push    esi
                push    edi
                mov     eax, dwSendSize
                cmp     eax, 8000h
                ja      @@err
                mov     ecx, eax
                mov     edx, eax
                xchg    al, ah
                mov     word ptr packet_buf,ax
                lea     edi, packet_buf+2
                mov     esi, pSendBuff
                rep     movsb
                lea     esi, packet_buf
                lea     ecx, [edx+2]
                xor     edx, edx
                mov     eax, edx
@@next_byte:
                mov     al, byte ptr [esi]
                add     edx, eax
                inc     esi
                loop    @@next_byte
                mov     byte ptr [edi],al
                lea     eax, [edi+1]
                sub     eax, offset packet_buf
                push    1000
                mov     Cmd_Recv_Size, 1000h
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    eax
                push    offset packet_buf
                push    offset CmdBin
                call    Flash_SendCmd
                cmp     eax, -1
                je      @@exit
                push    offset Cmd_Recv_Buf
                call    CheckAck
                jmp     @@exit
@@err:
                mov     eax, -1
@@exit:         
                pop     edi
                pop     esi

                ret
Flash_Bin       endp
                
Flash_Dump      proc	near dwAddress:DWORD, pBuffer:DWORD
                push    dwAddress
                push    offset Fmt_8Hex
                push    offset packet_buf
                call    wsprintfA
                add     esp,12
                push    1000
                mov     Cmd_Recv_Size,1000h
                push    offset Cmd_Recv_Size
                push    pBuffer
                push    8
                push    offset packet_buf
                push    offset CmdDump
                call    Flash_SendCmd

                ret
Flash_Dump      endp

Flash_Read      proc
arg_4           = dword ptr 8
arg_8           = dword ptr 0Ch
arg_C           = dword ptr 10h
                push    ebp
                mov     ebp,esp
                push    esi
                push    edi
                push    [ebp+arg_8]
                push    [ebp+arg_4]
                push    offset Fmt_READ
                push    offset packet_buf
                call    wsprintfA
                add     esp,16
                push    1000
                mov     Cmd_Recv_Size,1000h
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    13
                push    offset packet_buf
                push    offset CmdRead
                call    Flash_SendCmd
                test    eax,eax
                jnz     @@exit
                mov     esi,offset Cmd_Recv_Buf
                cmp     byte ptr [esi],2
                jne     @@error
                cmp     dword ptr [esi+1],'DAER' ;READ
                jne     @@error
                cmp     byte ptr [esi+5],1eh
                jne     @@error
                add     esi,8
                mov     ax,word ptr [esi-2]
                xchg    al,ah
                cwde
                mov     ecx,eax
                mov     edi,[ebp+arg_C]
                rep     movsb
                jmp     @@exit
@@error:
                mov     eax,-1
@@exit:
                pop     edi
                pop     esi
                leave
                ret    12
Flash_Read      endp

P2K00_Ping      proc    near
                cmp     TCI_IF, -1
                jz      @@fail
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    0
                push    offset Cmd_Send_Buf
                push    0FFFh                  ; PING
                call    P2K00_SendCMD
@@fail:
                ret
P2K00_Ping      endp


P2K05_Ping      proc    near
                cmp     TCI_IF, -1
                jz      @@fail
                push    P2KTimeOut
                mov     P2KTimeOut, 100h
                
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    0
                push    offset Cmd_Send_Buf
                push    0FFFh                  ; PING
                call    P2K05_SendCMD
                
                pop     P2KTimeOut
@@fail:
                ret
P2K05_Ping      endp


Test_P2K_ver proc
             
             call  P2K05_Ping
             cmp   eax,0
             jz    @@p05
             mov   P2K05,0
             jmp   @@done
@@p05:
             mov   P2K05,1
@@done:             
             ret
Test_P2K_ver endp

USB_WriteData   proc    near

arg_4           = dword ptr  8
arg_8           = dword ptr  0Ch
;arg_8           = dword ptr  10h

                push    ebp
                mov     ebp, esp

                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

;                push    offset msg_usb_event_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_reset_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:

                push    offset DevIO_Overlapped
                push    0
                push    5
                push    offset DevIO_Result
                mov     eax,[ebp+arg_8] ; InBuf_Size
                mov     eax, [eax]
                push    eax
                push    [ebp+arg_4]     ; InBuf
                push    80002014h
                push    TCI_IF
                call    DeviceIoControl

                push    2710h
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    TCI_IF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_wait_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:
                push    0
                push    [ebp+arg_8] ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    TCI_IF
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    TCI_IF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_result_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit

@@devio_ok:
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_write_ok
;                call    logstat
                mov     eax, 0
@@exit:
                leave
                ret    08h
USB_WriteData   endp

USB_WriteDataEx proc    near

arg_4           = dword ptr  8
arg_8           = dword ptr  0Ch
arg_C           = dword ptr  10h
arg_10          = dword ptr  14h
;arg_10          = dword ptr  18h

                push    ebp
                mov     ebp, esp
                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi

                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

;                push    offset msg_usb_event_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_reset_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:
                mov     edi, offset packet_buf
                mov     esi, [ebp+arg_4]
                mov     al, byte ptr [ebp+arg_C]
                stosb
                mov     eax,[ebp+arg_8] ; InBuf_Size
                mov     eax, [eax]
                stosd
                mov     ecx, eax
                rep     movsb
                
                
                push    offset DevIO_Overlapped
                push    0
                push    5
                push    offset DevIO_Result
                add     eax, 6
                push    eax
                push    offset packet_buf ; [ebp+arg_4]     ; InBuf
                push    80002018h
                push    Def_IF
                call    DeviceIoControl

                push    [ebp+arg_10]
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    Def_IF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_wait_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:
                push    0
                push    [ebp+arg_8] ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    Def_IF
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    Def_IF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_result_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit

@@devio_ok:
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_write_ok
;                call    logstat
                mov     eax, 0
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                ret    10h
USB_WriteDataEx endp

USB_ReadData    proc    near

arg_4           = dword ptr  8
arg_8           = dword ptr  0Ch
;arg_8           = dword ptr  10h

                push    ebp
                mov     ebp, esp

                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

;                push    offset msg_usb_event_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_reset_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:

                push    offset DevIO_Overlapped
                push    0
                push    1005h
                push    offset DevIO_Result
                mov     eax,[ebp+arg_8] ; InBuf_Size
                push    9
                push    [ebp+arg_4]     ; InBuf
                push    80002014h
                push    TCI_IF
                call    DeviceIoControl

                push    9C40h
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    TCI_IF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_wait_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:

                push    0
                push    [ebp+arg_8] ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    TCI_IF
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    TCI_IF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_result_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@devio_ok:
                mov     esi, [ebp+arg_8]
                mov     ecx, [esi]
                cmp     ecx, 4
                jnb     @@size_ok
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_size_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@size_ok:
                sub     ecx, 4
                mov     [esi], ecx
                mov     esi, offset DevIO_Result
                add     esi, 4
                mov     edi, [ebp+arg_4]
                rep     movsb
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_read_ok
;                call    logstat
                mov     eax, 0
@@exit:
                leave
                ret    08h
USB_ReadData    endp

USB_ReadDataEx  proc    near

arg_4           = dword ptr  8 ;lpRecvBuff
arg_8           = dword ptr  0Ch ; lpcbRecv
arg_C           = dword ptr  10h ; code=2
arg_10          = dword ptr  14h ; dwTimeout
;arg_10          = dword ptr  18h

                push    ebp
                mov     ebp, esp

                push    esi
                push    edi
                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

;                push    offset msg_usb_event_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_reset_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:

                mov     edi, offset packet_buf
                mov     al, byte ptr [ebp+arg_C]
                stosb
                mov     eax, [ebp+arg_8]
                mov     eax, [eax]
                stosd

                push    offset DevIO_Overlapped
                push    0
                push    1005h
                push    offset DevIO_Result
                push    5
                push    offset packet_buf
                push    8000201Ch
                push    Def_IF
                call    DeviceIoControl
                                
                call    GetLastError
                push    [ebp+arg_10]
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    Def_IF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_wait_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:

                push    0
                push    [ebp+arg_8] ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    Def_IF
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    Def_IF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_result_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@devio_ok:
                mov     esi, [ebp+arg_8]
                mov     ecx, [esi]
                cmp     ecx, 4
                jnb     @@size_ok
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_size_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@size_ok:
                sub     ecx, 4
                mov     [esi], ecx
                mov     esi, offset DevIO_Result
                add     esi, 4
                mov     edi, [ebp+arg_4]
                rep     movsb
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_read_ok
;                call    logstat
                mov     eax, 0
@@exit:
                pop     edi
                pop     esi

                leave
                ret    10h
USB_ReadDataEx  endp

USB_GetIFInfo   proc    near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h

                push    ebp
                mov     ebp, esp

                push    ecx
                push    esi
                push    edi

                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

;                push    offset msg_usb_event_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_reset_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:
                mov     eax, [ebp+arg_4]
                mov     IF_Info_cmd, eax

                push    offset DevIO_Overlapped
                push    offset IF_Info_recvd
                push    105h
                push    [ebp+arg_8]
                push    2
                push    offset IF_Info_cmd ; InBuf
                push    80002010h
                push    [ebp+arg_0]
                call    DeviceIoControl

                push    1388h
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    [ebp+arg_0]
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_wait_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:

                push    0
                push    offset IF_Info_recvd ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    [ebp+arg_0]
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    [ebp+arg_0]
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_result_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@devio_ok:
                cmp     IF_Info_recvd, 4
                jnb     @@size_ok
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_size_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@size_ok:
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_read_ok
;                call    logstat
                mov     ecx, [ebp+arg_8]
                mov     ecx, [ecx]
                mov     esi, [ebp+arg_8]
                add     esi, 4
                mov     edi, [ebp+arg_8]
@@str_loop:
                lodsw
                stosb
                loop    @@str_loop

                mov     eax, 0
@@exit:
                pop     edi
                pop     esi
                pop     ecx
                leave
                ret    0Ch
USB_GetIFInfo   endp


;------------- Phone initialize procs ----------------
COM_Find        proc	near
                push    ebp
                mov     ebp, esp
                push    edi
                push    ecx
                push    esi
                push    ebx

                mov     eax, dwRasSize
                mov     dwRasCb, eax
                
                push    offset dwRasDevices
                push    offset dwRasCb
                push    0
                call    RasEnumDevicesA
                
                push    dwRasCb
                push    0
                call    GlobalAlloc
                mov     lpRasDevInfo,eax
                push    eax

                mov     eax,lpRasDevInfo
                mov     ebx,dwRasSize
                mov     [eax],ebx
                
                push    offset dwRasDevices
                push    offset dwRasCb
                push    lpRasDevInfo
                call    RasEnumDevicesA
                
                xor     ecx,ecx

@@loop:                
                push    ecx
                cmp     ecx,dwRasDevices
                jae     @@fail 
                
                
                mov     esi, lpRasDevInfo
                add     esi, 4
                push    esi
                push    offset sRasModem
                call    lstrcmpA
                cmp     eax,0
                jnz     @@next_step
                
                mov     esi, lpRasDevInfo
                add     esi, 21
                push    offset sRasMoto
                push    esi
                call    StrStrIA
                cmp     eax,0
                jz      @@next_step

                mov     esi, lpRasDevInfo
                add     esi, 21
                push    esi 
                push    offset sRasMask
                push    offset keyval_buf
                call    wsprintfA
                add     esp, 0Ch
                jmp     @@good
                

@@next_step:
                pop     ecx
                mov     eax,dwRasSize
                add     lpRasDevInfo,eax
                inc     ecx
                jmp     @@loop
                
@@good:
                call    Switch_mode
                test    eax,eax
                jnz     @@next_step
                pop     ecx
                xor     eax,eax
                jmp     @@exit
@@fail:
                pop     ecx
                mov     eax, -1
@@exit:
                xchg    eax,dword ptr [esp]
                push    eax
                call    GlobalFree    
                pop     eax
                push    ebx
                push    esi
                pop     ecx
                pop     edi
                leave
                ret
COM_Find        endp

Switch_mode     proc	near
                push    ebp
                mov     ebp, esp

                push    -1
                push    0
                push    1 ; Create new
                push    0
                push    0
                push    0C0000000h ; generic RW
                push    offset keyval_buf
                call    CreateFileA
                mov     ComHandle, eax
                cmp     eax,0
                jnz     @@create_ok
                mov     eax, -1
                jmp     @@exit
@@create_ok:
                push    0
                push    offset at_readed
                push    0Bh
                cmp     HackModeTF,1
                jz      @@hack
                push    offset at_mode
                jmp     @@skip_hack
@@hack:
                push    offset tf_mode
                
@@skip_hack:                
           
                push    ComHandle
                call    WriteFile
                cmp     eax, 0
                jnz     @@write_ok
                push    ComHandle
                call    CloseHandle
                mov     eax, -1
                jmp     @@exit
@@write_ok:
                push    ComHandle
                call    CloseHandle
                mov     eax, 0
@@exit:
                leave
                ret
Switch_mode     endp

FindUSBClass    proc	near
                push    ebp
                mov     ebp, esp
                pusha

                push    12h             ; flags
                push    0               ; parent_hwnd
                push    0               ; enum
                push    offset DevClass ; class GUID
                call    SetupDiGetClassDevsA
                cmp     eax, -1
                jz      @@getclass_fail
                mov     ClassInfoSet, eax

                mov     DevIF_Index, 0

@@loop:
                mov     DevFound, 0
                push    offset DevIF_Data   ; DevIFData
                push    DevIF_Index         ; dev index
                push    offset DevClass     ; IF class GUID
                push    0                   ; dev info data
                push    ClassInfoSet
                mov     DevIF_Data, 1Ch     ; size
                call    SetupDiEnumDeviceInterfaces
                test    eax, eax
                jz      @@exit ; @@dev_enum_failed ; +

                push    0                    ; DevInfoData
                push    offset DevIF_ReqSize ; ReqSize
                push    0                    ; DevIFDetailSize
                push    0                    ; DevIFDetail
                push    offset DevIF_Data    ; DevIFData
                push    ClassInfoSet
                call    SetupDiGetDeviceInterfaceDetailA
                test    eax, eax
                jnz     @@dev_info_noerr

                call    GetLastError
                cmp     eax, 7Ah        ; err_insuff_buffer
                jnz     @@exit ; _Destroy_list

@@dev_info_noerr:
                push    DevIF_ReqSize ; 5Ah?
                push    40h
                call    GlobalAlloc
                mov     esi, eax
                test    esi, esi
                jz      @@exit ; _Destroy_list

                mov     dword ptr [esi], 5
                push    0               ; DevInfoData
                push    0               ; DevIF_Req_Size
                push    DevIF_ReqSize   ; DevIFDetailSize
                push    esi             ; DevIFDetail - dd size and str - path
                push    offset DevIF_Data ; DevIFData
                push    ClassInfoSet    ; devinfoset
                call    SetupDiGetDeviceInterfaceDetailA
                test    eax, eax
;                jz      @@Dev_GetDetail_failed
                jz      @@fail_gonext

                xor     eax,eax
                mov     al,[esi+22h] ; get IFindex
                and     al,0fh
                mov     IFindex,ax   ; store IFindex

                push    0
                push    40000000h ;FILE_FLAG_OVERLAPPED
                push    3
                push    0
                lea     edi, [esi+4]    ; DevIF path
                push    3
                push    0C0000000h
                push    edi
                call    CreateFileA
                mov     ebx, eax
                cmp     ebx, 0FFFFFFFFh
                jz      short @@fail_gonext

                push    offset str_buf
                push    0102h
                push    ebx
                call    USB_GetIFInfo
                
                push    offset str_buf
                lea     edi,str_motorola_tci
                push    edi
                call    lstrcmpA
                test    eax,eax
                jnz     @@not_tci
                mov     TCI_IF,ebx
                mov     DevType,1
                jmp     @@dev_found
@@fail_gonext:
                push    esi
                call    GlobalFree
                inc     DevIF_Index
                jmp     @@loop
                
@@not_tci:      mov     al,IsExInited
                test    al,al
                jz      @@not_phone
                lea     edi,str_motorola_fi
                push    offset str_buf
                push    edi
                call    lstrcmpA
                test    eax,eax
                jz      @@flash_found
                push    offset str_buf
                lea     edi,str_motorola_bi
                push    edi
                call    lstrcmpA
                test    eax,eax
                jnz     @@not_phone
@@flash_found:  mov     DevType,2
                mov     FI_IF,ebx
@@dev_found:    mov     Def_IF,ebx
                mov     DevFound, 1
                mov     Dev_Name_Ptr, esi
                mov     lpIFName,edi
                jmp     @@exit
@@not_phone:
                push    ebx
                call    CloseHandle
                inc     DevIF_Index
                jmp     @@loop


;@@dev_enum_failed:
;                call    GetLastError
;                jmp     @@exit_Destroy_list

;@@Dev_GetDetail_failed:

@@exit:
                push    ClassInfoSet
                call    SetupDiDestroyDeviceInfoList
@@getclass_fail:
                popa
                leave
                ret
FindUSBClass    endp


SwitchFromDataCard proc	near
           push 12h
           push 0
           push 0
           push offset guidMassStorage
           call SetupDiGetClassDevsA
           cmp  eax,-1
           jz @@failed1
           mov  hDeviceInfo, eax
           
           mov  dwMSDevCount,0
           
@@loop1:
           push offset DeviceInterfaceData
           push dwMSDevCount
           push offset guidMassStorage
           push 0
           push hDeviceInfo
           call SetupDiEnumDeviceInterfaces
           inc  dwMSDevCount
           cmp  eax,0
           jz   @@loop_done

           push 0
           push offset DeviceInterfaceDetailDataSize
           push 0
           push 0
           push offset DeviceInterfaceData
           push hDeviceInfo
           call SetupDiGetDeviceInterfaceDetailA

           push DeviceInterfaceDetailDataSize
           push 0
           call GlobalAlloc
           mov  pDeviceInterfaceDetailData, eax
           mov  esi, pDeviceInterfaceDetailData
           mov  dword ptr [esi], 5h

           push 0
           push 0
           push DeviceInterfaceDetailDataSize
           push pDeviceInterfaceDetailData
           push offset DeviceInterfaceData
           push hDeviceInfo
           call SetupDiGetDeviceInterfaceDetailA

           mov  eax, pDeviceInterfaceDetailData
           add  eax, 4
           mov  lpMSDevicePath, eax

           push offset lpDevMoto
           push lpMSDevicePath
           call StrStrIA
           cmp  eax,0
           jz   @@not_moto

           push 0
           push 20000000h
           push 00000003h
           push 0
           push 00000003h
           push 0C0000000h
           push lpMSDevicePath
           call CreateFileA
           mov  hMSDevice,eax

           push 0
           push offset nBytesReturned
           push 2Ch
           push offset SwitchModePacket
           push 2Ch
           push offset SwitchModePacket
           push 0004D014h
           push hMSDevice
           call DeviceIoControl

           push hMSDevice
           call CloseHandle 


@@not_moto:
           push pDeviceInterfaceDetailData
           call GlobalFree
           jmp  @@loop1           
           
@@loop_done:           
           
@@failed1:           
                   ret
SwitchFromDataCard endp

		.data

guidMassStorage                 db 07h, 63h, 0f5h, 53h, 0bfh, 0b6h, 0d0h, 11h, 94h, 0f2h, 00h, 0a0h, 0c9h, 1eh, 0fbh, 8bh
SwitchModePacket                db 2ch, 00, 00, 00, 00, 00, 0ch, 00, 01, 00, 00, 00, 00, 00, 00, 00, 19h, 00, 00, 00, 00, 00, 00, 00
                                db 00, 00, 00, 00, 0d6h, 00, 00, 00, 00, 00, 00, 00, 00, 00, 08, 00, 00, 00, 00, 00
dwMSDevCount                    dd 00
DeviceInterfaceData             dd 28
                                dd 0h,0h,0h,0h
                                dd 00h
                                dd 00h
pDeviceInterfaceDetailData      dd 00h
DeviceInterfaceDetailDataSize   dd 00h
lpDevMoto                       db 'motorola', 00h
lpMSDevicePath                  dd 00h 
hMSDevice                       dd 00h
nBytesReturned                  dd 00h 
hDeviceInfo                     dd 00h


ManualCOM        dd 0

dwRasCb       dd 152
dwRasSize     dd 152
dwRasDevices  dd 0
lpRasDevInfo  dd 0
sRasModem     db 'modem', 00h
sRasMoto      db 'Motorola USB Modem', 00h
sRasMask      db '\\.\%s', 0 

FileRecCount dd 0

IFindex       dw 0000h
;MI            db '&MI_',00h

P2K05            db 0
IsExInited       db 0
DevType          db 0
P2KTimeOut       dd 2710h


Our_Handle       dd 0
Mon_CB           dd 0
TCI_IF           dd -1
FI_IF            dd -1
Def_IF           dd 0
USB_Last_Err     dd 0
Thread_Handle    dd 0
Thread_Id        dd 0
Thread_Suspended dd 0
HackModeTF       dd 0
Inited3          dd 0
SwitchToAT_Buff  db  40h, 01h, 00h, 00h, 01h, 00h, 00h, 00h, 00h
lpIFName         dd 0
Key_Class_handle dd 0
DevFound         dd 0
File_opened      dd 0
; PSTGetDeviceInterface data
Dev_Name_Ptr     dd 0

str_motorola_tci  db 'Motorola Test Command',0
str_motorola_fi   db 'Motorola Flash',0
str_motorola_bi   db 'Motorola Boot',0
Fmt_8Hex          db '%0.8lX',0
Fmt_2Hex          db '%0.2X',0
Fmt_READ          db '%0.8lX,%0.4lX',0
CmdAddr           db "ADDR",0
CmdJump           db "JUMP",0
CmdBin            db "BIN",0
CmdDump           db "DUMP",0
CmdRead           db "READ",0
RespAck           db 2,"ACK"
;str_serialcom_key db 'HARDWARE\DEVICEMAP\SERIALCOMM',0
str_devclass_key  db 'SYSTEM\CurrentControlSet\Control\DeviceClasses\{4e1e1e15-52d7-11d4-852d-00105aa6f80b}\%s\#\Control',0
;str_usbser        db '\Device\USBSER000', 0
at_mode           db 'at+mode=8', 0Dh, 0Ah, 0
tf_mode           db 'at+mode=24', 0Dh, 0Ah, 0
;str_usb_modem     db '\\.\Motorola USB Modem' ,0,0,0,0,0,0,0,0


                align 4

; SetupUI data structures

ClassInfoSet    dd 0
DevIF_Index     dd 0

DevIF_Data      dd 0 ; size
DevIF_GUID      dd 0
DevIF_Flags     dd 0
DevIF_res       dd 0
                dd 0
                dd 0
                dd 0


DevIF_ReqSize   dd 0

DevClass        dd 4E1E1E15h, 11D452D7h, 10002D85h, 0BF8A65Ah

;msg_cmd_write_fail  db 'CMD: Data write fail!', 0Dh, 0Ah, 0
;msg_cmd_timeout     db 'CMD: Answer wait timeout!', 0Dh, 0Ah, 0
;msg_cmd_read_fail   db 'CMD: Data read fail!', 0Dh, 0Ah, 0
;msg_cmd_answer_fail db 'CMD: Answer packet invalid!', 0Dh, 0Ah, 0

;msg_usb_write_ok    db 'USB: Write data ok', 0Dh, 0Ah, 0
;msg_usb_read_ok     db 'USB: Read data ok', 0Dh, 0Ah, 0
;msg_usb_event_fail  db 'USB: Event create failed!', 0Dh, 0Ah, 0
;msg_usb_reset_fail  db 'USB: Event reset failed!', 0Dh, 0Ah, 0
;msg_usb_wait_fail   db 'USB: IO Time-out!', 0Dh, 0Ah, 0
;msg_usb_result_fail db 'USB: IO Failed!', 0Dh, 0Ah, 0
;msg_usb_size_fail   db 'USB: Answer size invlid!', 0Dh, 0Ah, 0

DevIO_Overlapped  dd 0
                  dd 0
                  dd 0
                  dd 0
DevIO_Event       dd 0
DevIO_Result      db 1010h dup (?) ; 1008h
;-----------------------------

CommTimeouts       dd ?
CommTimeouts_Multi dd ?
CommTimeouts_Const dd ?
CommTimeouts_W_Multi dd ?
CommTimeouts_W_Const dd ?

ComHandle       dd ?
at_readed       dd ?
Key_handle      dd ?
keyval_type     dd ?
keyval_size     dd ?
keyval_buf      db 100h dup (?)

Cmd_Send_Size    dd ?
Cmd_Recv_Size    dd ?
Cmd_Send_Buf     db 1000h dup (?)
Cmd_Recv_Buf     db 1000h dup (?)

Packet_ID        dw ?
                 dw ?
packet_size      dd ?
packet_buf       db 1000h dup (?)
packet_size2     dd ?
packet_buf2      db 1000h dup (?)
status_read_size dd ?
status_read_buf  db 1000h dup (?) ; 0Ch bytes
data_read_size   dd ?
data_read_buf    dd 1000h dup (?)
ReadStatus_Ticks dd ?

IF_Info_cmd      dd ?
IF_Info_recvd    dd ?

str_buf         db 1000h dup (?)

seem_num        dw ?
seem_rec        dw ?
seem_ofs        dw ?
seem_bytes      dw ?
seem_data       db 2710h dup (?)
seem_buf        db 2710h dup (?)

stelem_result   dd ?
seem_read_bytes dd ?

FileList_RecSize dd ?
Search_Buf       db 1000h dup (?)

		end